//
//	test EncircledEnergyDataServer
//
#include <iostream>

#include "common.h"
#include "CalServer.h"
//#include "EncircledEnergyDataServer.h"
#include "PsfDataServer.h"
#include "Xmm.h"

using namespace std;

int main(int argc, char **argv)
{
#if 0
	calServer.setInstrument(Xmm::EPN);
	EncircledEnergyDataServer *eds = 0; eds = calServer.getAtom(eds);
	double emin = eds->eValidity().lo();
	const EncircledEnergyFunction &eefunc = eds->encircledEnergy(emin);
	for (double r=0.1; r<=25.; r+=.1)
		cout<<"EE("<<r<<"\")="<<eefunc(r)<<endl;
#endif

	if (argc == 2)
		calServer.ccf()->registerNewCifEntry(argv[1]);

	calServer.setInstrument(Xmm::EPN);

// Test the EXTENDED mode
	calServer.state()->accuracyLevel()->set(EXTENDED);
	PsfDataServer *pds = 0; pds = calServer.getAtom(pds);
	Psf &psf = pds->psf(2500.,600.0,0.0);
	cout<<"E=2500,Theta=10amin,R=20asec"<<psf.encircledEnergy(0.7267)<<endl;
        psf.setParameters(100.0,0.0,0.0);
	cout<<"E=100,Theta=0amin,R=20asec"<<psf.encircledEnergy(0.7267)<<endl;
        psf.setParameters(1500.0,0.0,0.0);
	cout<<"E=1500,Theta=0amin,R=20asec"<<psf.encircledEnergy(0.7267)<<endl;
        psf.setParameters(10000.0,0.0,0.0);
	cout<<"E=10000,Theta=0amin,R=20asec"<<psf.encircledEnergy(0.7267)<<endl;
        
        psf.setPosAngle(0.1); // Add a position angle of 0.1 rads
	cout<<"E=10000,Theta=0amin,R=20asec"<<psf.encircledEnergy(0.7267)<<endl;

// Test the ELLIPTICAL mode
	calServer.setInstrument(Xmm::EMOS1);
	calServer.state()->accuracyLevel()->set(ELLBETA);
	PsfDataServer *pds2 = 0; pds2 = calServer.getAtom(pds2);
	Psf &psf2 = pds2->psf(2750.,720.0,0.0);
//	cout<<"E=2500,Theta=10amin,R=1asec"<<psf2.encircledEnergy(0.00363)<<endl;
//	cout<<"E=2500,Theta=10amin,R=2asec"<<psf2.encircledEnergy(0.0726)<<endl;
//	cout<<"E=2500,Theta=10amin,R=3asec"<<psf2.encircledEnergy(0.1089)<<endl;
//	cout<<"E=2500,Theta=10amin,R=6asec"<<psf2.encircledEnergy(0.2089)<<endl;
//	cout<<"E=2500,Theta=10amin,R=300asec"<<psf2.encircledEnergy(10.89)<<endl;
        cout<<"Setting parameters, 100,0,0"<<endl;
        psf2.setParameters(100.0,0.0,0.0);
	cout<<"E=100,Theta=0amin,R=3,300 asec"<<psf2.encircledEnergy(0.1089)<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(1500.0,0.0,0.0);
	cout<<"E=1500,Theta=0amin,R=300 asec"<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(4500.0,0.0,0.0);
	cout<<"E=4500,Theta=0amin,R=300 asec"<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(7000.0,0.0,0.0);
	cout<<"E=7000,Theta=0amin,R=300 asec"<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(2750.0,0.0,0.0);
//	cout<<"E=2750,Theta=0amin,R=20,300asec"<<psf2.encircledEnergy(0.7267)<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(10000.0,0.0,0.0);
//	cout<<"E=10000,Theta=0amin,R=20,300asec"<<psf2.encircledEnergy(0.7267)<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(100.0,720.0,0.0);
//	cout<<"E=100,Theta=10amin,R=3,300 asec"<<psf2.encircledEnergy(0.1089)<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(2750.0,720.0,0.0);
//	cout<<"E=2750,Theta=10amin,R=20,300asec"<<psf2.encircledEnergy(0.7267)<<psf2.encircledEnergy(10.89)<<endl;
        psf2.setParameters(10000.0,720.0,0.0);
//	cout<<"E=10000,Theta=10amin,R=20,300asec"<<psf2.encircledEnergy(0.7267)<<psf2.encircledEnergy(10.89)<<endl;
   //     double ellip = psf2.ellipticity();
  //      cout<<"Ellipticity: "<<ellip<<endl;

	return 0;
}
