//
//	test the cal rawx2mm calls
//
#include <iostream>
#include <iomanip>
#include <cstdlib>
#include "CalServer.h"
#include "Xmm.h"
#include "GeometryDataServer.h"
#include "common.h"

using namespace std;

int main(int argc, char **argv)
{
	if (argc != 4) {
		cerr<<"Usage: "<<argv[0]<<" <pixX> <pixY> <ccd>\n";
		return 1;
	}

	calServer.setInstrument(Xmm::EMOS1);
	Ccd ccd = atoi(argv[3]);
	calServer.state()->ccd()->set(ccd);
	calServer.state()->randomize()->set(false);
	calServer.state()->temperature()->set(293.);
	calServer.state()->temperatureCamera()->set(293.);

	double xmm, ymm, zmm;
	CalReal64Vector x(&xmm, 1), y(&ymm, 1), z(&zmm, 1);
	short xint = atoi(argv[1]), yint = atoi(argv[2]);
	CalInt16Vector xpix(&xint, 1), ypix(&yint, 1);
	cout<<xint<<'/'<<yint<<'['<<ccd<<"] = ";

	GeometryDataServer *cdf = 0; cdf = calServer.getAtom(cdf);
	XmmPixelList pix = cdf->chipCoordList(xpix, ypix);
	XmmCartesianPointList cpl = pix.toCamCoord1(x, y, z);
	cout<<xmm<<'/'<<ymm<<'/'<<zmm<<" = ";

	ccd = cdf->onCcd(xmm, ymm);
	pix = cpl.toChipCoord();
	cout<<pix.x()[0]<<'/'<<pix.y()[0]<<'['<<ccd<<"]\n";

	return 0;
}
