//-----------------------------------------------------------------------------
//
//						XMM Science Analysis System (SAS)
//					   (c) 1997-2010 European Space Agency
//
//-----------------------------------------------------------------------------
//
//	SpecQualityServer.h --- miscellaneous Cal atoms
//
//	DESCRIPTION:
//
//	CHANGE HISTORY:
//		RDS, 2009-04-13: 1.0: - original
//
//	AUTHOR:
//		R. Saxton, 2009-04-13
//
//	REFERENCES:
//		[1]: Software Specification Document for the XMM Science Analysis
//			 Subsystem, M. Dahlem et. al., 
//
//	$Header: /sasbuild/repositories/sasdev/sas/packages/cal/src/SpecQualityServer.h,v 1.1 2009/04/15 15:08:32 rsaxton Exp $
//

#ifndef SPEC_QUAL_H
#define SPEC_QUAL_H

#include "Ccf.h"
#include "CalAtomsBase.h"

#include <vector>

//
//	---( mode parameters )------------------------------------------------
//
class SpecQualityServer : public CalAtom {
public:
	friend class CalAtomCollection<SpecQualityServer>;

	//	default constructor - does nothing
	SpecQualityServer() {}

	static unsigned id() { return Ccf::SpecQual; }

	short nGroups() const { return _ngroups; }
        std::vector<short> ranges() const { return _ranges; }
	float gainSlopeMin() const { return _gslope_min; }
	float gainSlopeMax() const { return _gslope_max; }
	float gainOffsetMin() const { return _offset_min; }
	float gainOffsetMax() const { return _offset_max; }

	~SpecQualityServer() {}

private:
        std::vector<short> _ranges;
        short _ngroups;
	float _gslope_min,
		  _gslope_max,
		  _offset_min,
		  _offset_max;

};


#endif

